using System;
using Mercury.QTP.CustomServer;
using System.Drawing;
using System.Windows.Forms;

namespace WinButton
{
    #region Replay Interface
    [ReplayInterface]
    public interface IWinButton
    {
        void CustomClick();
    }
    #endregion

    /// <summary>
    /// Summary description for WinButtonRecordReplayServer.
    /// </summary>
    public class WinButtonRecordReplayServer :
        CustomServerBase,
        IWinButton
    {
        #region Ctor - Not to Use
        public WinButtonRecordReplayServer()
        {
        }
        #endregion

        #region Private Property : WinButton
        private Button WinButton
        {
            get { return (Button)this.SourceControl; }
        }
        #endregion


        /////////////////
        // Record Logic
        /////////////////
        #region IRecord override Methods
        public override void InitEventListener()
        {
            AddHandler("Click", new EventHandler(WinButton_Click));
        }

        public override void ReleaseEventListener()
        {
        }
        #endregion

        #region Record Event - Button : Click
        void WinButton_Click(object sender, EventArgs e)
        {
            RecordFunction("CustomClick", RecordingMode.RECORD_SEND_LINE);
        }
        #endregion



        // ///////////////
        // Replay Logic
        // ///////////////
        protected delegate void NoParamVoidDel();
       
        #region Replay Action : CustomClick
        public void CustomClick()
        {
            Delegate del = new NoParamVoidDel(fnCustomClick);
            SourceControl.Invoke(del);
        }
        private void fnCustomClick()
        {
            Point pt = new Point(WinButton.Size.Width / 2,
                                 WinButton.Size.Height / 2);

            this.MouseClick(pt.X, pt.Y, MOUSE_BUTTON.LEFT_MOUSE_BUTTON);
        }
        #endregion
        
    }
}
